Digitizing: Ctrl+Z (and other cancelation tools) reset the features to its initial state (or at least more 

than one action).

2017-12-08 03:33 PM - Harrissou Santanna

Status: Closed

Priority: High

Assignee: Nyall Dawson

Category: Digitising

Affected QGIS version:master Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution: fixed/implemented

Crashes QGIS or corrupts data:Yes Copied to github as #: 25555

Description

I'm doing some digitizing on a geopackage layer

And it looks like when hitting ctrl-Z, it reverts more than the last action. At the same time, the Undo/Redo panel just jumps one action

above (hence not coherent with the state of actions)

To reproduce, take a feature and open the undo/redo panel, select the node tool

Move a point

delete a point

move another point or group of points

delete a point

press ctrl z.

Here, it brings the feature to its original state (not just one action reverted as it should be). The same thing happens when you click ANY

row in the undo panel

Another interesting part is what happens at the same time in that panel:

1/When you press Ctrl+Z, the focus in the panel jumped one step back despite the state of the feature being reset. But actually, if you

have clicked ANY row in the Undo panel to revert your action(s), it would have reverted all the actions too

2/if you click on the previous actions in the Undo panel, you'll notice that nothing happens

3/If you click on a more recent action than in step 2, then you'll redo your latest actions.

It looks like there's something messy with cancelation steps.

I checked the "Corrupts data" status because if you don't have whole feature in front of you, you may not notice revertion of some

changes.

Associated revisions

Revision 70644f1d - 2018-02-13 09:48 AM - Nyall Dawson

Fix undo stack does not correctly roll back geometry edits

in a granular manner

Fixes #17658

History

#1 - 2018-02-13 08:19 AM - Nyall Dawson

- Assignee set to Nyall Dawson

- Status changed from Open to In Progress
#2 - 2018-02-13 08:55 AM - Nyall Dawson

- Pull Request or Patch supplied changed from No to Yes

PR at https://github.com/qgis/QGIS/pull/6330

#3 - 2018-02-13 09:48 AM - Nyall Dawson

- % Done changed from 0 to 100

- Status changed from In Progress to Closed

Applied in changeset commit:qgis|70644f1ddd51fbdc85b99a51aa1f9150856c7036.

#4 - 2018-02-22 09:15 AM - Giovanni Manghi

- Resolution set to fixed/implemented
